Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sun.tdk.signaturetest.model
Class ClassDescription

    java.lang.Object
      com.sun.tdk.signaturetest.model.MemberDescription
          com.sun.tdk.signaturetest.model.ClassDescription

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class ClassDescription

extends MemberDescription

ClassDescription lists all public or protected members of some class or interface. Given some MemberDescription instance, it is possible to findMember a List of MemberDescription references for all members characterized with that shorter MemberDescription.

Several abstract methods for finding nested classes are declared in ClassDescription, which are implemented in the following two classes:

- ReflClassDescription using reflection, and
- SigFileClassDescription using previously created table of nested classes.

See Also:
  Serialized Form

Nested Class Summary
`static class` | `ClassDescription.TypeParam`
`static class` | `ClassDescription.TypeParameterList`

Field Summary
`protected MemberCollection` | `members` List of members of that class described by `this` instance.
`static java.lang.String` | `OUTER_PREFIX`
`protected ClassDescription.TypeParameterList` | `typeparamList`

Fields inherited from class com.sun.tdk.signaturetest.model.MemberDescription
`ARGS_DELIMITER, CLASS_DELIMITER, delimiter, EMPTY_THROW_LIST, JAVA_LANG, MEMBER_DELIMITER, NO_ARGS, NO_DECLARING_CLASS, NO_TYPE, THROWS_DELIMITER`

Constructor Summary
`ClassDescription()` Description for empty class containing no members.

Method Summary
`void` | `add(MemberDescription x)` Adds new class member.
`void` | `addXClasses(java.lang.String name)`
`void` | `addXFields(java.lang.String name)`
`boolean` | `containsMember(MemberDescription newMember)`
`void` | `createConstructors(int size)`
`void` | `createFields(int size)`
`void` | `createInterfaces(int size)`
`void` | `createMethods(int size)`
`void` | `createNested(int size)`
`boolean` | `equals(java.lang.Object o)`
`MemberDescription` | `findMember(MemberDescription requiredMember)`
`ClassHierarchy` | `getClassHierarchy()`
`ConstructorDescr` | `getConstructor(int i)`
`InnerDescr[]` | `getDeclaredClasses()`
`ConstructorDescr[]` | `getDeclaredConstructors()`
`FieldDescr[]` | `getDeclaredFields()`
`MethodDescr[]` | `getDeclaredMethods()`
`java.util.Set` | `getDependences()`
`FieldDescr` | `getField(int i)`
`SuperInterface[]` | `getInterfaces()`
`java.util.Set` | `getInternalClasses()`
`java.util.Set` | `getInternalFields()`
`int` | `getMembersCount(MemberType memberType, java.lang.String fqname)`
`java.util.Iterator` | `getMembersIterator()` Return Enumeration of MemberDescription getMembersIterator for all members of that class described by `this` instance.
`MethodDescr` | `getMethod(int i)`
`java.lang.String` | `getName()`
`java.lang.String` | `getOuterClass()`
`static java.lang.String` | `getPackageInfo(java.lang.String packageName)`
`java.lang.String` | `getPackageName()`
`static java.lang.String` | `getPackageName(java.lang.String name)` Given the (qualified) class `name`, extract its package name.
`java.lang.String` | `getQualifiedName()`
`SuperClass` | `getSuperClass()`
`java.util.ArrayList` | `getTypeBounds()`
`ClassDescription.TypeParameterList` | `getTypeparamList()`
`java.util.Set` | `getXClasses()`
`java.util.Set` | `getXFields()`
`int` | `hashCode()`
`boolean` | `isAnonymousClass()`
`boolean` | `isClass()` Check if `this` is a class item.
`boolean` | `isCompatible(MemberDescription m)`
`boolean` | `isDocumentedAnnotation()`
`boolean` | `isPackageInfo()`
`boolean` | `isTiger()`
`boolean` | `isTopClass()`
`void` | `populateDependences(MemberDescription[] members, java.util.Set dependences)`
`protected void` | `populateDependences(java.util.Set dependences)`
`void` | `removeThrows()`
`void` | `setConstructor(int i, ConstructorDescr c)`
`void` | `setConstructors(ConstructorDescr[] ctors)`
`void` | `setField(int i, FieldDescr f)`
`void` | `setFields(FieldDescr[] fields)`
`void` | `setHierarchy(ClassHierarchy hierarchy)`
`void` | `setInterface(int i, SuperInterface interf)`
`void` | `setInterfaces(SuperInterface[] interfs)`
`void` | `setInternalClasses(java.util.Set classes)`
`void` | `setInternalFields(java.util.Set fields)`
`void` | `setMembers(MemberCollection members)`
`void` | `setMethod(int i, MethodDescr m)`
`void` | `setMethods(MethodDescr[] methods)`
`void` | `setNested(int i, InnerDescr m)`
`void` | `setNestedClasses(InnerDescr[] ncls)`
`void` | `setSuperClass(SuperClass m)`
`void` | `setTiger(boolean tiger)`
`void` | `setTypeparamList(ClassDescription.TypeParameterList typeparamList)`
`void` | `setXClasses(java.util.Set classes)`
`void` | `setXFields(java.util.Set fileds)`
`java.lang.String` | `toString()`

Methods inherited from class com.sun.tdk.signaturetest.model.MemberDescription
`addDependency, addModifier, clone, getAnnoList, getArgs, getClassShortName, getDeclaringClassName, getMemberType, getModifiers, getSimplifiedArgs, getSimplifiedType, getThrowables, getThrows, getType, getTypeName, getTypeName, getTypeParameters, hasModifier, isAbstract, isConstructor, isField, isFinal, isInner, isInterface, isMarked, isMethod, isPrivate, isProtected, isPublic, isStatic, isSuperClass, isSuperInterface, mark, removeModifier, setAnnoList, setArgs, setDeclaringClass, setModifiers, setNoDeclaringClass, setThrowables, setType, setTypeParameters, setupClassName, setupClassName, setupGenericClassName, setupGenericClassName, setupInnerClassName, setupMemberName, setupMemberName, unmark, valueToString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### OUTER_PREFIX

    public static final java.lang.String OUTER_PREFIX

See Also:
  Constant Field Values

### typeparamList

    protected ClassDescription.TypeParameterList typeparamList

### members

    protected transient MemberCollection members

  List of members of that class described by `this` instance. This is a hashtable indexed by MemberDescription instances, and containing a List of MemberDescription instances describing all members characterized with the same MemberDescription.

  See Also:
    `MemberDescription`

Constructor Detail

### ClassDescription

    public ClassDescription()

  Description for empty class containing no members.

  See Also:
    `members`

Method Detail

### equals

    public boolean equals(java.lang.Object o)

  Overrides:
    `equals` in class `MemberDescription`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `MemberDescription`

### getQualifiedName

    public java.lang.String getQualifiedName()

  Overrides:
    `getQualifiedName` in class `MemberDescription`

### getName

    public java.lang.String getName()

  Overrides:
    `getName` in class `MemberDescription`

### isCompatible

    public boolean isCompatible(MemberDescription m)

  Specified by:
    `isCompatible` in class `MemberDescription`

### containsMember

    public boolean containsMember(MemberDescription newMember)

### findMember

    public MemberDescription findMember(MemberDescription requiredMember)

### getMembersCount

    public int getMembersCount(MemberType memberType,
                               java.lang.String fqname)

### isAnonymousClass

    public boolean isAnonymousClass()

### getTypeBounds

    public java.util.ArrayList getTypeBounds()

### setMembers

    public void setMembers(MemberCollection members)

### getPackageInfo

    public static java.lang.String getPackageInfo(java.lang.String packageName)

### getTypeparamList

    public ClassDescription.TypeParameterList getTypeparamList()

### setTypeparamList

    public void setTypeparamList(ClassDescription.TypeParameterList typeparamList)

### isPackageInfo

    public boolean isPackageInfo()

### getPackageName

    public java.lang.String getPackageName()

### getPackageName

    public static java.lang.String getPackageName(java.lang.String name)

  Given the (qualified) class `name`, extract its package name.

### isTiger

    public boolean isTiger()

### setTiger

    public void setTiger(boolean tiger)

### add

    public void add(MemberDescription x)

  Adds new class member.

### getMembersIterator

    public java.util.Iterator getMembersIterator()

  Return Enumeration of MemberDescription getMembersIterator for all members of that class described by `this` instance.

  See Also:
    `members`, `MemberDescription`

### removeThrows

    public void removeThrows()

### getDeclaredConstructors

    public ConstructorDescr[] getDeclaredConstructors()

### getDeclaredFields

    public FieldDescr[] getDeclaredFields()

### getDeclaredMethods

    public MethodDescr[] getDeclaredMethods()

### getInterfaces

    public SuperInterface[] getInterfaces()

### getOuterClass

    public java.lang.String getOuterClass()

### getDeclaredClasses

    public InnerDescr[] getDeclaredClasses()

### createInterfaces

    public void createInterfaces(int size)

### setInterface

    public void setInterface(int i,
                             SuperInterface interf)

### setInterfaces

    public void setInterfaces(SuperInterface[] interfs)

### createFields

    public void createFields(int size)

### createMethods

    public void createMethods(int size)

### createConstructors

    public void createConstructors(int size)

### createNested

    public void createNested(int size)

### setConstructor

    public void setConstructor(int i,
                               ConstructorDescr c)

### setConstructors

    public void setConstructors(ConstructorDescr[] ctors)

### setMethods

    public void setMethods(MethodDescr[] methods)

### setMethod

    public void setMethod(int i,
                          MethodDescr m)

### setField

    public void setField(int i,
                         FieldDescr f)

### setFields

    public void setFields(FieldDescr[] fields)

### getField

    public FieldDescr getField(int i)

### getMethod

    public MethodDescr getMethod(int i)

### getConstructor

    public ConstructorDescr getConstructor(int i)

### setNestedClasses

    public void setNestedClasses(InnerDescr[] ncls)

### setNested

    public void setNested(int i,
                          InnerDescr m)

### setSuperClass

    public void setSuperClass(SuperClass m)

### getSuperClass

    public SuperClass getSuperClass()

### isClass

    public boolean isClass()

  Description copied from class: `MemberDescription`
  Check if `this` is a class item.

  Overrides:
    `isClass` in class `MemberDescription`

### setInternalFields

    public void setInternalFields(java.util.Set fields)

### setInternalClasses

    public void setInternalClasses(java.util.Set classes)

### getInternalFields

    public java.util.Set getInternalFields()

### getXFields

    public java.util.Set getXFields()

### setXFields

    public void setXFields(java.util.Set fileds)

### addXFields

    public void addXFields(java.lang.String name)

### getXClasses

    public java.util.Set getXClasses()

### setXClasses

    public void setXClasses(java.util.Set classes)

### addXClasses

    public void addXClasses(java.lang.String name)

### getInternalClasses

    public java.util.Set getInternalClasses()

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### isTopClass

    public boolean isTopClass()

### getDependences

    public java.util.Set getDependences()

### populateDependences

    protected void populateDependences(java.util.Set dependences)

  Overrides:
    `populateDependences` in class `MemberDescription`

### populateDependences

    public void populateDependences(MemberDescription[] members,
                                    java.util.Set dependences)

### isDocumentedAnnotation

    public boolean isDocumentedAnnotation()

### getClassHierarchy

    public ClassHierarchy getClassHierarchy()

### setHierarchy

    public void setHierarchy(ClassHierarchy hierarchy)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD